function NotificationMessageController($scope, $rootScope, $timeout, ZhLogger, templateManager) {
	$rootScope.notificationMessages = [];
	var messageCount = 0;

	var messageContainer = $('.zh-notification-messages');

	$scope.removeMessage = function(message) {
		var item = messageContainer.find('#' + message.id);
		if (item) {
			item.animate({
				opacity: 0
			}, 300, function() {
				item.animate({
					height: 0
				}, 300, function() {
					var index = $rootScope.notificationMessages.indexOf(message);
					if (index > -1) {
						$rootScope.notificationMessages.splice(index, 1);
						$scope.$apply();
					}
				});
			});
		}
	};

	$scope.$on("addNotificationMessage", function(e, message) {
		var messageId = 'msg-' + messageCount++;
		message.id = messageId;
		var index = $rootScope.notificationMessages.push(message);
		if (message.type == 'alert') {
			ZhLogger.warning(message.text);
		} else if (message.type == 'error') {
			ZhLogger.error(message.text);
		}

		templateManager.updateTemplate();

		if (message.type != 'error' || message.time) {
			$timeout(function() {
				$scope.removeMessage(message);
			}, message.time || 3000);
		}
	});
}
